Index: pjproject/trunk/pjlib/src/pj/ssl_sock_dump.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/ssl_sock_dump.c	(revision 5658)
+++ pjproject/trunk/pjlib/src/pj/ssl_sock_dump.c	(revision 5659)
@@ -106,6 +106,4 @@
     /* Subject alternative name extension */
     if (ci->subj_alt_name.cnt) {
-	unsigned i;
-
 	len = pj_ansi_snprintf(p, end-p, "%ssubjectAltName extension\n", 
 			       indent);
Index: pjproject/trunk/pjmedia/src/pjmedia-codec/opus.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-codec/opus.c	(revision 5658)
+++ pjproject/trunk/pjmedia/src/pjmedia-codec/opus.c	(revision 5659)
@@ -458,4 +458,5 @@
 					 pjmedia_codec_param *attr )
 {
+    PJ_UNUSED_ARG(factory);
     TRACE_((THIS_FILE, "%s:%d: - TRACE", __FUNCTION__, __LINE__));
 
@@ -521,4 +522,5 @@
     struct opus_codec_factory *f = (struct opus_codec_factory*) factory;
 
+    PJ_UNUSED_ARG(ci);
     TRACE_((THIS_FILE, "%s:%d: - TRACE", __FUNCTION__, __LINE__));
 
@@ -932,4 +934,6 @@
     int fec = 0;
 
+    PJ_UNUSED_ARG(output_buf_len);
+
     pj_mutex_lock (opus_data->mutex);
 
@@ -1019,4 +1023,5 @@
     pjmedia_frame *inframe;
 
+    PJ_UNUSED_ARG(output_buf_len);
     pj_mutex_lock (opus_data->mutex);
 
@@ -1024,6 +1029,6 @@
         /* Recover the first packet? Don't think so, fill it with zeroes. */
 	pj_uint16_t samples_per_frame;
-	samples_per_frame = (opus_data->cfg.sample_rate * 
-			     opus_data->ptime) / 1000;
+	samples_per_frame = (pj_uint16_t)(opus_data->cfg.sample_rate * 
+					  opus_data->ptime) / 1000;
 	output->type = PJMEDIA_FRAME_TYPE_AUDIO;
 	output->size = samples_per_frame << 1;
Index: pjproject/trunk/pjmedia/src/pjmedia-videodev/colorbar_dev.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-videodev/colorbar_dev.c	(revision 5658)
+++ pjproject/trunk/pjmedia/src/pjmedia-videodev/colorbar_dev.c	(revision 5659)
@@ -600,5 +600,4 @@
         if (d->vfi->plane_cnt == 1) {
             for (i = 0; i < 3; ++i) {
-                pj_uint8_t *ptr;
                 unsigned j, k, inc_ptr;
                 pj_size_t dot_size = DOT_SIZE;
@@ -622,5 +621,5 @@
 
             for (i = 0; i < 3; ++i) {
-                pj_uint8_t *ptr, c;
+                pj_uint8_t c;
                 unsigned j;
                 pj_size_t dot_size = DOT_SIZE;
Index: pjproject/trunk/pjmedia/src/pjmedia/avi_player.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/avi_player.c	(revision 5658)
+++ pjproject/trunk/pjmedia/src/pjmedia/avi_player.c	(revision 5659)
@@ -613,5 +613,5 @@
 {
     struct avi_reader_port *fport = (struct avi_reader_port*)this_port;
-    pj_status_t status;
+    pj_status_t status = PJ_SUCCESS;
     pj_ssize_t size_read = 0, size_to_read = 0;
 
@@ -620,6 +620,4 @@
     /* We encountered end of file */
     if (fport->eof) {
-	pj_status_t status = PJ_SUCCESS;
-
 	PJ_LOG(5,(THIS_FILE, "File port %.*s EOF",
 		  (int)fport->base.info.name.slen,
Index: pjproject/trunk/pjmedia/src/pjmedia/echo_webrtc.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/echo_webrtc.c	(revision 5658)
+++ pjproject/trunk/pjmedia/src/pjmedia/echo_webrtc.c	(revision 5659)
@@ -284,4 +284,7 @@
     sample * out_buf_ptr;
 
+    PJ_UNUSED_ARG(options);
+    PJ_UNUSED_ARG(reserved);
+
     /* Sanity checks */
     PJ_ASSERT_RETURN(echo && rec_frm && play_frm, PJ_EINVAL);
@@ -329,5 +332,5 @@
         status = WebRtcAec_Process(echo->AEC_inst, &buf_ptr,
                                    echo->channel_count, &out_buf_ptr,
-                                   echo->subframe_len, echo->tail, 0);
+                                   echo->subframe_len, (int16_t)echo->tail, 0);
 #endif
         if (status != 0) {
Index: pjproject/trunk/pjmedia/src/pjmedia/vid_codec_util.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/vid_codec_util.c	(revision 5658)
+++ pjproject/trunk/pjmedia/src/pjmedia/vid_codec_util.c	(revision 5659)
@@ -430,5 +430,4 @@
 		char *p;
 		pj_uint8_t *nal;
-		pj_status_t status;
 
 		/* Find field separator ',' */
Index: pjproject/trunk/pjmedia/src/test/vid_codec_test.c
===================================================================
--- pjproject/trunk/pjmedia/src/test/vid_codec_test.c	(revision 5658)
+++ pjproject/trunk/pjmedia/src/test/vid_codec_test.c	(revision 5659)
@@ -279,6 +279,5 @@
     {
         pj_str_t codec_id_st;
-        unsigned info_cnt = 1;
-        const pjmedia_vid_codec_info *codec_info;
+        unsigned info_cnt = 1;        
 
         /* Lookup codec */
Index: pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app_cli.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app_cli.c	(revision 5658)
+++ pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app_cli.c	(revision 5659)
@@ -2915,5 +2915,5 @@
 
 #if PJSUA_HAS_VIDEO
-static pj_status_t add_video_command(pj_cli_t *cli)
+static pj_status_t add_video_command(pj_cli_t *c)
 {
     char* video_command =
@@ -3054,5 +3054,5 @@
 
     pj_str_t xml = pj_str(video_command);
-    return pj_cli_add_cmd_from_xml(cli, NULL,
+    return pj_cli_add_cmd_from_xml(c, NULL,
 				   &xml, cmd_video_handler,
 				   NULL, get_choice_value);
Index: pjproject/trunk/pjsip-apps/src/pjsua/winrt/cli/wp8/pjsua_cli_wp8.csproj
===================================================================
--- pjproject/trunk/pjsip-apps/src/pjsua/winrt/cli/wp8/pjsua_cli_wp8.csproj	(revision 5658)
+++ pjproject/trunk/pjsip-apps/src/pjsua/winrt/cli/wp8/pjsua_cli_wp8.csproj	(revision 5659)
@@ -75,4 +75,25 @@
     <WarningLevel>4</WarningLevel>
   </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x64' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>Bin\x64\Debug</OutputPath>
+    <DefineConstants>DEBUG;TRACE;SILVERLIGHT;WINDOWS_PHONE</DefineConstants>
+    <NoStdLib>true</NoStdLib>
+    <NoConfig>true</NoConfig>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x64' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>Bin\x64\Release</OutputPath>
+    <DefineConstants>TRACE;SILVERLIGHT;WINDOWS_PHONE</DefineConstants>
+    <NoStdLib>true</NoStdLib>
+    <NoConfig>true</NoConfig>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>    
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|ARM' ">
     <DebugSymbols>true</DebugSymbols>
@@ -124,10 +145,14 @@
     <Content Include="Assets\teluu-logo.png" />
   </ItemGroup>
-  <ItemGroup>
-    <ProjectReference Include="..\comp\pjsua_cli_wp8_comp.vcxproj">
-      <Project>{e75efd41-c7f5-44c8-8ff1-a310d920989d}</Project>
-      <Name>pjsua_cli_wp8_comp</Name>
-    </ProjectReference>
-  </ItemGroup>
+  <Choose>
+    <When Condition="'$(API_Family)'=='WinPhone8'">
+      <ItemGroup>
+        <ProjectReference Include="..\comp\pjsua_cli_wp8_comp.vcxproj">
+          <Project>{e75efd41-c7f5-44c8-8ff1-a310d920989d}</Project>
+          <Name>pjsua_cli_wp8_comp</Name>
+        </ProjectReference>
+      </ItemGroup>
+    </When>
+  </Choose>
   <Import Project="$(MSBuildExtensionsPath)\Microsoft\$(TargetFrameworkIdentifier)\$(TargetFrameworkVersion)\Microsoft.$(TargetFrameworkIdentifier).$(TargetFrameworkVersion).Overrides.targets" />
   <Import Project="$(MSBuildExtensionsPath)\Microsoft\$(TargetFrameworkIdentifier)\$(TargetFrameworkVersion)\Microsoft.$(TargetFrameworkIdentifier).CSharp.targets" />
Index: pjproject/trunk/pjsip/src/pjsua-lib/pjsua_vid.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/pjsua_vid.c	(revision 5658)
+++ pjproject/trunk/pjsip/src/pjsua-lib/pjsua_vid.c	(revision 5659)
@@ -1043,5 +1043,5 @@
 	if (si->dir & PJMEDIA_DIR_ENCODING && !call->local_hold)
 	{
-            pjsua_acc *acc = &pjsua_var.acc[call_med->call->acc_id];
+            pjsua_acc *acc_enc = &pjsua_var.acc[call_med->call->acc_id];
 	    pjsua_vid_win *w;
 	    pjsua_vid_win_id wid;
@@ -1074,5 +1074,5 @@
 					//acc->cfg.vid_cap_dev,
 					PJSUA_HIDE_WINDOW,
-                                        acc->cfg.vid_wnd_flags,
+                                        acc_enc->cfg.vid_wnd_flags,
                                         NULL,
 					&wid);